﻿/*
Author: Andy Watt
Revised: 4-22-2009
Website: http://www.wastedpotential.com

This class handles the rollover and rollout animations for buttons
*/

package com.wastedpotential {
    import flash.events.MouseEvent;
	import flash.display.MovieClip;
    
    public class BasicButton extends MovieClip {

		public var isHighlighted:Boolean = false;
		
		
		//===== CONSTRUCTOR =====
		public function BasicButton() {
			this.mouseChildren = false; //not really needed when using ROLL_OVER and ROLL_OUT, but just in case...
			this.buttonMode = true;
			this.addEventListener(MouseEvent.ROLL_OVER, onMouseOver);
			this.addEventListener(MouseEvent.ROLL_OUT, onMouseOut);
		} 	   
	   
		//===== handles the rollover response for a button: ===== 
		private function onMouseOver(evt:MouseEvent):void{
			highlightMe();
		}
		
		//===== handles the rollout response for a button: =====
		private function onMouseOut(evt:MouseEvent):void{
			unhighlightMe();
		}
		   
		//===== plays the highlight animation for a button: =====
		public function highlightMe():void {
			if (!isHighlighted) {
				this.gotoAndPlay("in");  
				isHighlighted = true;
			}
		}
	   
		//===== plays the unhighlight animation for a button: =====
		public function unhighlightMe():void {
			if (isHighlighted) {
				this.gotoAndPlay("out");
				isHighlighted = false;
			}
		}
		
	} //end class
} //end package